diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -1224,59 +3320,168 @@
        mainly to avoid copyrect using invalid screen contents - not sure
        if we'd need it otherwise. */
 
-    if (appData.useShm)
-      XSync(dpy, False);
+	if (appData.useShm) {
+		XSync(dpy, False);
+	} else
 #endif
+	{
+		/* we do it always now. */
+		XSync(dpy, False);
+	}
+	
+	if (skip_XtUpdate || skip_incFBU) {
+		;
+	} else if (appData.pipelineUpdates) {
+		;
+	} else if (!SendIncrementalFramebufferUpdateRequest()) {
+		return False;
+	}
 
-    if (!SendIncrementalFramebufferUpdateRequest())
-      return False;
-
-    break;
+	break;
   }
 
   case rfbBell:
   {
-    Window toplevelWin;
+	Window toplevelWin;
 
-    XBell(dpy, 0);
+	if (appData.useBell) {
+		XBell(dpy, 0);
+	}
+
+	if (appData.raiseOnBeep) {
+		toplevelWin = XtWindow(toplevel);
+		XMapRaised(dpy, toplevelWin);
+	}
 
-    if (appData.raiseOnBeep) {
-      toplevelWin = XtWindow(toplevel);
-      XMapRaised(dpy, toplevelWin);
+	break;
     }
 
-    break;
-  }
+    case rfbServerCutText:
+    {
+	if (!ReadFromRFBServer(((char *)&msg) + 1, sz_rfbServerCutTextMsg - 1)) {
+		return False;
+	}
 
-  case rfbServerCutText:
-  {
-    if (!ReadFromRFBServer(((char *)&msg) + 1,
-			   sz_rfbServerCutTextMsg - 1))
-      return False;
+	msg.sct.length = Swap32IfLE(msg.sct.length);
 
-    msg.sct.length = Swap32IfLE(msg.sct.length);
+	if (serverCutText) {
+		free(serverCutText);
+	}
 
-    if (serverCutText)
-      free(serverCutText);
+	serverCutText = malloc(msg.sct.length+1);
 
-    serverCutText = malloc(msg.sct.length+1);
+	if (!ReadFromRFBServer(serverCutText, msg.sct.length)) {
+		return False;
+	}
 
-    if (!ReadFromRFBServer(serverCutText, msg.sct.length))
-      return False;
+	serverCutText[msg.sct.length] = 0;
 
-    serverCutText[msg.sct.length] = 0;
+	newServerCutText = True;
 
-    newServerCutText = True;
+	break;
+    }
 
-    break;
-  }
+    case rfbTextChat:
+    {
+	char *buffer = NULL;
+	if (!ReadFromRFBServer(((char *)&msg) + 1, sz_rfbTextChatMsg - 1)) {
+		return False;
+	}
+	msg.tc.length = Swap32IfLE(msg.tc.length);
+	switch(msg.tc.length) {
+	case rfbTextChatOpen:
+		if (appData.termChat) {
+			printChat("\n*ChatOpen*\n\nSend: ", True);
+		} else {
+			printChat("\n*ChatOpen*\n", True);
+		}
+		appData.chatActive = True;
+		break;
+	case rfbTextChatClose:
+		printChat("\n*ChatClose*\n", False);
+		appData.chatActive = False;
+		break;
+	case rfbTextChatFinished:
+		printChat("\n*ChatFinished*\n", False);
+		appData.chatActive = False;
+		break;
+	default:
+		buffer = (char *)malloc(msg.tc.length+1);
+		if (!ReadFromRFBServer(buffer, msg.tc.length)) {
+			free(buffer);
+			return False;
+		}
+		buffer[msg.tc.length] = '\0';
+		appData.chatActive = True;
+		GotChatText(buffer, msg.tc.length);
+		free(buffer);
+	}
+	break;
+    }
 
-  default:
-    fprintf(stderr,"Unknown message type %d from VNC server\n",msg.type);
-    return False;
-  }
+    case rfbResizeFrameBuffer:
+    {
+	rfbResizeFrameBufferMsg rsmsg;
+	if (!ReadFromRFBServer(((char *)&rsmsg) + 1, sz_rfbResizeFrameBufferMsg - 1)) {
+		return False;
+	}
+	si.framebufferWidth  = Swap16IfLE(rsmsg.framebufferWidth);
+	si.framebufferHeight = Swap16IfLE(rsmsg.framebufferHeight);
+	fprintf(stderr,"UltraVNC ReSize: %dx%d\n", si.framebufferWidth, si.framebufferHeight);
+	ReDoDesktop();
+	break;
+    }
 
-  return True;
+    case rfbRestartConnection:
+    {
+	rfbRestartConnectionMsg rc;
+	int len;
+	char *rs_str;
+	char buf[5] = "\xff\xff\xff\xff";
+	fprintf(stderr, "rfbRestartConnection. type=%d\n", (int) rc.type);
+	if (!ReadFromRFBServer((char *)&rc + 1, sz_rfbRestartConnectionMsg - 1)) {
+		return False;
+	}
+	len = Swap32IfLE(rc.length);
+	fprintf(stderr, "rfbRestartConnection. pad1=%d\n", (int) rc.pad1);
+	fprintf(stderr, "rfbRestartConnection. pad2=%d\n", (int) rc.pad2);
+	fprintf(stderr, "rfbRestartConnection. len=%d\n", len);
+	if (len) {
+		rs_str = (char *)malloc(2*len);	
+		if (!ReadFromRFBServer(rs_str, len)) {
+			return False;
+		}
+		restart_session_pw = rs_str;
+		restart_session_len = len;
+	}
+	if (!WriteExact(rfbsock, buf, 4)) {
+		return False;
+	}
+	InitialiseRFBConnection();
+	SetVisualAndCmap();
+	SetFormatAndEncodings();
+	DesktopCursorOff();
+	SendFramebufferUpdateRequest(0, 0, si.framebufferWidth, si.framebufferHeight, False);
+
+	break;
+    }
+
+    default:
+	fprintf(stderr,"Unknown message type %d from VNC server\n",msg.type);
+	return False;
+    }
+
+	if (appData.fileActive) {
+		if (filexfer_sock < 0 && filexfer_listen < 0) {
+			appData.fileActive = False;
+			SendFramebufferUpdateRequest(0, 0, 1, 1, False);
+		} else {
+/*fprintf(stderr, "CFX: A\n"); */
+			CheckFileXfer();
+		}
+	}
+
+    return True;
 }
 
 
@@ -1296,26 +3501,93 @@
 #define CONCAT2(a,b) a##b
 #define CONCAT2E(a,b) CONCAT2(a,b)
 
+#define CONCAT3(a,b,c) a##b##c
+#define CONCAT3E(a,b,c) CONCAT3(a,b,c)
+
+static unsigned char* frameBuffer = NULL;
+static int frameBufferLen = 0;
+
+#ifdef TURBOVNC
+#include "turbovnc/turbojpeg.h"
+tjhandle tjhnd=NULL;
+static char *compressedData = NULL;
+static char *uncompressedData = NULL;
+#define CopyDataToImage CopyDataToScreen
+static void turbovnc_FillRectangle(XGCValues *gcv, int rx, int ry, int rw, int rh) {
+	if (!appData.useXserverBackingStore) {
+		FillScreen(rx, ry, rw, rh, gcv->foreground);
+	} else {
+		XChangeGC(dpy, gc, GCForeground, gcv);
+		XFillRectangle(dpy, desktopWin, gc, rx, ry, rw, rh);
+	}
+}
+static void CopyImageToScreen(int x, int y, int w, int h) {
+	put_image(x, y, x, y, w, h, 0);
+}
+#endif
+
 #define BPP 8
 #include "rre.c"
 #include "corre.c"
 #include "hextile.c"
 #include "zlib.c"
+
+#ifdef TURBOVNC
+#undef FillRectangle
+#define FillRectangle turbovnc_FillRectangle
+#include "turbovnc/tight.c"
+#undef FillRectangle
+#else
 #include "tight.c"
+#endif
+
+#include "zrle.c"
 #undef BPP
+
 #define BPP 16
 #include "rre.c"
 #include "corre.c"
 #include "hextile.c"
 #include "zlib.c"
+
+#ifdef TURBOVNC
+#undef FillRectangle
+#define FillRectangle turbovnc_FillRectangle
+#include "turbovnc/tight.c"
+#undef FillRectangle
+#else
 #include "tight.c"
+#endif
+
+#include "zrle.c"
+#define REALBPP 15
+#include "zrle.c"
 #undef BPP
+
 #define BPP 32
 #include "rre.c"
 #include "corre.c"
 #include "hextile.c"
 #include "zlib.c"
+
+#ifdef TURBOVNC
+#undef FillRectangle
+#define FillRectangle turbovnc_FillRectangle
+#include "turbovnc/tight.c"
+#undef FillRectangle
+#else
 #include "tight.c"
+#endif
+
+#include "zrle.c"
+#define REALBPP 24
+#include "zrle.c"
+#define REALBPP 24
+#define UNCOMP 8
+#include "zrle.c"
+#define REALBPP 24
+#define UNCOMP -8
+#include "zrle.c"
 #undef BPP
 
 /*
@@ -1325,23 +3597,27 @@
 static void
 ReadConnFailedReason(void)
 {
-  CARD32 reasonLen;
-  char *reason = NULL;
+	CARD32 reasonLen;
+	char *reason = NULL;
 
-  if (ReadFromRFBServer((char *)&reasonLen, sizeof(reasonLen))) {
-    reasonLen = Swap32IfLE(reasonLen);
-    if ((reason = malloc(reasonLen)) != NULL &&
-        ReadFromRFBServer(reason, reasonLen)) {
-      fprintf(stderr,"VNC connection failed: %.*s\n", (int)reasonLen, reason);
-      free(reason);
-      return;
-    }
-  }
+	if (ReadFromRFBServer((char *)&reasonLen, sizeof(reasonLen))) {
+		reasonLen = Swap32IfLE(reasonLen);
+		if ((reason = malloc(reasonLen)) != NULL &&
+		    ReadFromRFBServer(reason, reasonLen)) {
+			int len = (int) reasonLen < sizeof(msgbuf) - 10 ? (int) reasonLen : sizeof(msgbuf) - 10;
+			sprintf(msgbuf,"VNC connection failed: %.*s\n", len, reason);
+			wmsg(msgbuf, 1);
+			free(reason);
+			return;
+		}
+	}
 
-  fprintf(stderr, "VNC connection failed\n");
+	sprintf(msgbuf, "VNC connection failed\n");
+	wmsg(msgbuf, 1);
 
-  if (reason != NULL)
-    free(reason);
+	if (reason != NULL) {
+		free(reason);
+	}
 }
 
 /*
@@ -1358,9 +3634,9 @@
 	    "  %s significant bit in each byte is leftmost on the screen.\n",
 	    (format->bigEndian ? "Most" : "Least"));
   } else {
-    fprintf(stderr,"  %d bits per pixel.\n",format->bitsPerPixel);
+    fprintf(stderr,"  %d bits per pixel.  ",format->bitsPerPixel);
     if (format->bitsPerPixel != 8) {
-      fprintf(stderr,"  %s significant byte first in each pixel.\n",
+      fprintf(stderr,"%s significant byte first in each pixel.\n",
 	      (format->bigEndian ? "Most" : "Least"));
     }
     if (format->trueColour) {
@@ -1462,4 +3738,3 @@
 
   cinfo->src = &jpegSrcManager;
 }
-
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rre.c vnc_unixsrc/vncviewer/rre.c
--- vnc_unixsrc.orig/vncviewer/rre.c	2000-06-11 08:00:53.000000000 -0400
+++ vnc_unixsrc/vncviewer/rre.c	2008-10-05 15:16:30.000000000 -0400
@@ -29,6 +29,18 @@
 #define HandleRREBPP CONCAT2E(HandleRRE,BPP)
 #define CARDBPP CONCAT2E(CARD,BPP)
 
+#define FillRectangle(x, y, w, h, color)  \
+	{ \
+		XGCValues _gcv; \
+		_gcv.foreground = color; \
+		if (!appData.useXserverBackingStore) { \
+			FillScreen(x, y, w, h, _gcv.foreground); \
+		} else { \
+			XChangeGC(dpy, gc, GCForeground, &_gcv); \
+			XFillRectangle(dpy, desktopWin, gc, x, y, w, h); \
+		} \
+	}
+
 static Bool
 HandleRREBPP (int rx, int ry, int rw, int rh)
 {
@@ -49,11 +61,19 @@
 #if (BPP == 8)
   gcv.foreground = (appData.useBGR233 ? BGR233ToPixel[pix] : pix);
 #else
+#if (BPP == 16)
+  gcv.foreground = (appData.useBGR565 ? BGR565ToPixel[pix] : pix);
+#else
   gcv.foreground = pix;
 #endif
+#endif
 
+#if 0
   XChangeGC(dpy, gc, GCForeground, &gcv);
   XFillRectangle(dpy, desktopWin, gc, rx, ry, rw, rh);
+#else
+  FillRectangle(rx, ry, rw, rh, gcv.foreground);
+#endif
 
   for (i = 0; i < hdr.nSubrects; i++) {
     if (!ReadFromRFBServer((char *)&pix, sizeof(pix)))
@@ -70,13 +90,23 @@
 #if (BPP == 8)
     gcv.foreground = (appData.useBGR233 ? BGR233ToPixel[pix] : pix);
 #else
+#if (BPP == 16)
+    gcv.foreground = (appData.useBGR565 ? BGR565ToPixel[pix] : pix);
+#else
     gcv.foreground = pix;
 #endif
+#endif
 
+#if 0
     XChangeGC(dpy, gc, GCForeground, &gcv);
     XFillRectangle(dpy, desktopWin, gc, rx + subrect.x, ry + subrect.y,
 		   subrect.w, subrect.h);
+#else
+    FillRectangle(rx + subrect.x, ry + subrect.y, subrect.w, subrect.h, gcv.foreground);
+#endif
   }
 
   return True;
 }
+
+#undef FillRectangle
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/selection.c vnc_unixsrc/vncviewer/selection.c
--- vnc_unixsrc.orig/vncviewer/selection.c	2004-03-03 04:11:52.000000000 -0500
+++ vnc_unixsrc/vncviewer/selection.c	2010-02-25 23:28:48.000000000 -0500
@@ -43,13 +43,16 @@
 				unsigned long* length, int* format);
 static void LoseSelection(Widget w, Atom *selection);
 
-static Bool iAmSelectionOwner = False;
+static Bool PrimarySelectionOwner = False;
+static Bool ClipboardSelectionOwner = False;
 static Time prevSelectionTime = 0L;
 static Time cutBufferTime = 0L;
 
 #define TIME_LATER(a, b) ((a) != 0 && ((b) == 0 || (INT32)((a) - (b)) > 0))
 
 
+static Atom clipboard_atom = None;
+
 /*
  * InitialiseSelection() must be called after realizing widgets (because
  * otherwise XtGetSelectionValue() fails).  We register events on the root
@@ -62,22 +65,28 @@
  * available.
  */
 
-void
-InitialiseSelection()
-{
+static int dbg_sel = -1;
+
+void InitialiseSelection() {
 #if XtSpecificationRelease >= 6
-  XtRegisterDrawable(dpy, DefaultRootWindow(dpy), toplevel);
+	XtRegisterDrawable(dpy, DefaultRootWindow(dpy), toplevel);
 #else
-  _XtRegisterWindow(DefaultRootWindow(dpy), toplevel);
+	_XtRegisterWindow(DefaultRootWindow(dpy), toplevel);
 #endif
-  XSelectInput(dpy, DefaultRootWindow(dpy), PropertyChangeMask);
+	XSelectInput(dpy, DefaultRootWindow(dpy), PropertyChangeMask);
 
-  XtAddRawEventHandler(toplevel, PropertyChangeMask, False, CutBufferChange,
-		       NULL);
+	XtAddRawEventHandler(toplevel, PropertyChangeMask, False, CutBufferChange, NULL);
 
-  XtGetSelectionValue(toplevel, XA_PRIMARY,
+	clipboard_atom = XInternAtom(dpy, "CLIPBOARD", False);
+
+	XtGetSelectionValue(toplevel, XA_PRIMARY,
 		      XInternAtom(dpy, "TIMESTAMP", False),
 		      GetInitialSelectionTimeCallback, NULL, CurrentTime);
+
+	if (dbg_sel < 0) {
+		dbg_sel = 0;
+		if (getenv("SSVNC_DEBUG_SELECTION")) dbg_sel = 1;
+	}
 }
 
 
@@ -93,13 +102,16 @@
 				Atom* selection, Atom* type, XtPointer value,
 				unsigned long* length, int* format)
 {
-  if (value && *format == 32 && *length == 1)
-    prevSelectionTime = *(CARD32 *)value;
-  else
-    prevSelectionTime = 0L;
-
-  if (value)
-    XtFree(value);
+	if (value && *format == 32 && *length == 1) {
+		prevSelectionTime = *(CARD32 *)value;
+	} else {
+		prevSelectionTime = 0L;
+	}
+
+	if (value) {
+		XtFree(value);
+	}
+	if (w || clientData || selection || type || value || length || format) {}
 }
 
 
@@ -121,26 +133,30 @@
 void
 SelectionToVNC(Widget w, XEvent *event, String *params, Cardinal *num_params)
 {
-  Bool always = False;
+	Bool always = appData.sendAlways;
+	Atom sendsel = XA_PRIMARY;
 
-  if (*num_params != 0) {
-    if (strcmp(params[0],"always") == 0) {
-      always = True;
-    } else if (strcmp(params[0],"new") == 0) {
-      always = False;
-    } else {
-      fprintf(stderr,"Invalid params: SelectionToVNC(always|new)\n");
-      return;
-    }
-  }
-
-  if (always) {
-    XtGetSelectionValue(w, XA_PRIMARY, XA_STRING, GetSelectionCallback, NULL,
-			TimeFromEvent(event));
-  } else {
-    XtGetSelectionValue(w, XA_PRIMARY, XInternAtom(dpy, "TIMESTAMP", False),
-			GetSelectionTimeCallback, NULL, TimeFromEvent(event));
-  }
+	if (*num_params != 0) {
+		if (strcmp(params[0],"always") == 0) {
+			always = True;
+		} else if (strcmp(params[0],"new") == 0) {
+			always = False;
+		} else {
+			fprintf(stderr,"Invalid params: SelectionToVNC(always|new)\n");
+			return;
+		}
+	}
+	if (appData.sendClipboard && clipboard_atom != None) {
+		sendsel = clipboard_atom;
+	}
+	if (dbg_sel) fprintf(stderr, "SelectionToVNC %s\n", sendsel == XA_PRIMARY ? "PRIMARY" : "CLIPBOARD");
+
+	if (always) {
+		XtGetSelectionValue(w, sendsel, XA_STRING, GetSelectionCallback, NULL, TimeFromEvent(event));
+	} else {
+		XtGetSelectionValue(w, sendsel, XInternAtom(dpy, "TIMESTAMP", False), GetSelectionTimeCallback, NULL, TimeFromEvent(event));
+	}
+	if (w || event || params || num_params) {}
 }
 
 
@@ -158,10 +174,13 @@
   int len = *length;
   char *str = (char *)value;
 
-  if (str)
-    SendClientCutText(str, len);
-  else
-    SendCutBuffer();
+	if (str) {
+		if (dbg_sel) fprintf(stderr, "SendClientCutText len: %d\n", len);
+		SendClientCutText(str, len);
+	} else if (!getenv("VNCVIEWER_NO_CUTBUFFER")) {
+		SendCutBuffer();
+	}
+	if (w || clientData || selection || type || value || length || format) {}
 }
 
 
@@ -180,26 +199,24 @@
 			 Atom* type, XtPointer value, unsigned long* length,
 			 int* format)
 {
-  if (value && *format == 32 && *length == 1) {
+	if (value && *format == 32 && *length == 1) {
+		Time t = *(CARD32 *)value;
 
-    Time t = *(CARD32 *)value;
-
-    if (TIME_LATER(t, prevSelectionTime)) {
-      prevSelectionTime = t;
-      XtGetSelectionValue(w, XA_PRIMARY, XA_STRING, GetSelectionCallback, NULL,
-			  CurrentTime);
-    }
-
-  } else {
-
-    if (TIME_LATER(cutBufferTime, prevSelectionTime)) {
-      prevSelectionTime = cutBufferTime;
-      SendCutBuffer();
-    }
-  }
-
-  if (value)
-    XtFree(value);
+		if (TIME_LATER(t, prevSelectionTime)) {
+			prevSelectionTime = t;
+			XtGetSelectionValue(w, XA_PRIMARY, XA_STRING, GetSelectionCallback, NULL, CurrentTime);
+		}
+	} else if (!getenv("VNCVIEWER_NO_CUTBUFFER")) {
+		if (TIME_LATER(cutBufferTime, prevSelectionTime)) {
+			prevSelectionTime = cutBufferTime;
+			SendCutBuffer();
+		}
+	}
+
+	if (value) {
+		XtFree(value);
+	}
+	if (w || clientData || selection || type || value || length || format) {}
 }
 
 
@@ -209,16 +226,17 @@
  */
 
 static void
-SendCutBuffer()
-{
-  char *str;
-  int len;
+SendCutBuffer() {
+	char *str;
+	int len;
 
-  str = XFetchBytes(dpy, &len);
-  if (!str) return;
+	if (dbg_sel) fprintf(stderr, "SendCutBuffer len: %d\n", len);
 
-  SendClientCutText(str, len);
-  XFree(str);
+	str = XFetchBytes(dpy, &len);
+	if (!str) return;
+
+	SendClientCutText(str, len);
+	XFree(str);
 }
 
 
@@ -230,10 +248,12 @@
 static void
 CutBufferChange(Widget w, XtPointer ptr, XEvent *ev, Boolean *cont)
 {
-  if (ev->type != PropertyNotify || ev->xproperty.atom != XA_CUT_BUFFER0)
-    return;
+	if (ev->type != PropertyNotify || ev->xproperty.atom != XA_CUT_BUFFER0) {
+		return;
+	}
 
-  cutBufferTime = ev->xproperty.time;
+	cutBufferTime = ev->xproperty.time;
+	if (w || ptr || cont) {}
 }
 
 
@@ -249,36 +269,69 @@
 void
 SelectionFromVNC(Widget w, XEvent *event, String *params, Cardinal *num_params)
 {
-  Bool always = False;
-  Time t = TimeFromEvent(event);
-
-  if (*num_params != 0) {
-    if (strcmp(params[0],"always") == 0) {
-      always = True;
-    } else if (strcmp(params[0],"new") == 0) {
-      always = False;
-    } else {
-      fprintf(stderr,"Invalid params: SelectionFromVNC(always|new)\n");
-      return;
-    }
-  }
-
-  if (t == CurrentTime) {
-    fprintf(stderr,"Error in translations: SelectionFromVNC() must act on "
-	    "event with time field\n");
-    return;
-  }
-
-  if (!serverCutText || (!always && !newServerCutText))
-    return;
-
-  newServerCutText = False;
-
-  XStoreBytes(dpy, serverCutText, strlen(serverCutText));
-  if (XtOwnSelection(desktop, XA_PRIMARY, t, ConvertSelection, LoseSelection,
-		     NULL)) {
-    iAmSelectionOwner = True;
-  }
+	Bool always = False;
+	Time t = TimeFromEvent(event);
+	int hold_primary   = 0;
+	int hold_clipboard = 0;
+
+	if (dbg_sel) fprintf(stderr, "SelectionFromVNC\n");
+
+	if (*num_params != 0) {
+		if (strcmp(params[0],"always") == 0) {
+			always = True;
+		} else if (strcmp(params[0],"new") == 0) {
+			always = False;
+		} else {
+			fprintf(stderr,"Invalid params: SelectionFromVNC(always|new)\n");
+			return;
+		}
+	}
+
+	if (t == CurrentTime) {
+		fprintf(stderr,"Error in translations: SelectionFromVNC() must act on "
+		    "event with time field\n");
+		return;
+	}
+
+	if (!serverCutText || (!always && !newServerCutText)) {
+		return;
+	}
+
+	newServerCutText = False;
+
+	if (appData.appShare) {
+		if (strstr(serverCutText, "X11VNC_APPSHARE_CMD:") == serverCutText) {
+			/* do something with it? */
+			return;
+		}
+	}
+
+	XStoreBytes(dpy, serverCutText, strlen(serverCutText));
+
+	if (appData.recvText == NULL) {
+		appData.recvText = strdup("both");
+	}
+	if (!strcasecmp(appData.recvText, "primary")) {
+		hold_primary = 1;
+	} else if (!strcasecmp(appData.recvText, "clipboard")) {
+		hold_clipboard = 1;
+	} else {
+		hold_primary = hold_clipboard = 1;
+	}
+
+	if (!hold_primary) {
+		;
+	} else if (XtOwnSelection(desktop, XA_PRIMARY, t, ConvertSelection, LoseSelection, NULL)) {
+		PrimarySelectionOwner = True;
+		if (dbg_sel) fprintf(stderr, "Own PRIMARY\n");
+	}
+	if (!hold_clipboard || clipboard_atom == None) {
+		;
+	} else if (XtOwnSelection(desktop, clipboard_atom, t, ConvertSelection, LoseSelection, NULL)) {
+		ClipboardSelectionOwner = True;
+		if (dbg_sel) fprintf(stderr, "Own CLIPBOARD\n");
+	}
+	if (w || event || params || num_params) {}
 }
 
 
@@ -293,37 +346,36 @@
 		 XtPointer* value, unsigned long* length, int* format)
 {
 
-  if (*target == XA_STRING && serverCutText != NULL) {
-    *type = XA_STRING;
-    *length = strlen(serverCutText);
-    *value = (XtPointer)XtMalloc(*length);
-    memcpy((char*)*value, serverCutText, *length);
-    *format = 8;
-    return True;
-  }
+	if (*target == XA_STRING && serverCutText != NULL) {
+		*type = XA_STRING;
+		*length = strlen(serverCutText);
+		*value = (XtPointer)XtMalloc(*length);
+		memcpy((char*)*value, serverCutText, *length);
+		*format = 8;
+		return True;
+	}
 
-  if (XmuConvertStandardSelection(w, CurrentTime, selection, target, type,
+	if (XmuConvertStandardSelection(w, CurrentTime, selection, target, type,
 				  (XPointer*)value, length, format)) {
-    if (*target == XInternAtom(dpy, "TARGETS", False)) {
-      /* add STRING to list of standard targets */
-      Atom* targetP;
-      Atom* std_targets = (Atom*)*value;
-      unsigned long std_length = *length;
-
-      *length = std_length + 1;
-      *value = (XtPointer)XtMalloc(sizeof(Atom)*(*length));
-      targetP = *(Atom**)value;
-      *targetP++ = XA_STRING;
-      memmove((char*)targetP, (char*)std_targets, sizeof(Atom)*std_length);
-      XtFree((char*)std_targets);
-      *type = XA_ATOM;
-      *format = 32;
-      return True;
-    }
-
-    return True;
-  }
-  return False;
+		if (*target == XInternAtom(dpy, "TARGETS", False)) {
+			/* add STRING to list of standard targets */
+			Atom* targetP;
+			Atom* std_targets = (Atom*)*value;
+			unsigned long std_length = *length;
+
+			*length = std_length + 1;
+			*value = (XtPointer)XtMalloc(sizeof(Atom)*(*length));
+			targetP = *(Atom**)value;
+			*targetP++ = XA_STRING;
+			memmove((char*)targetP, (char*)std_targets, sizeof(Atom)*std_length);
+			XtFree((char*)std_targets);
+			*type = XA_ATOM;
+			*format = 32;
+			return True;
+		}
+		return True;
+	}
+	return False;
 }
 
 
@@ -332,7 +384,13 @@
  */
 
 static void
-LoseSelection(Widget w, Atom *selection)
-{
-  iAmSelectionOwner = False;
+LoseSelection(Widget w, Atom *selection) {
+	if (*selection == XA_PRIMARY) {
+		if (dbg_sel) fprintf(stderr, "lost PRIMARY\n");
+  		PrimarySelectionOwner = False;
+	} else if (clipboard_atom != None && *selection == clipboard_atom) {
+		if (dbg_sel) fprintf(stderr, "lost CLIPBOARD\n");
+  		ClipboardSelectionOwner = False;
+	}
+	if (w) {}
 }
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/shm.c vnc_unixsrc/vncviewer/shm.c
--- vnc_unixsrc.orig/vncviewer/shm.c	2000-06-11 08:00:53.000000000 -0400
+++ vnc_unixsrc/vncviewer/shm.c	2010-02-25 23:40:58.000000000 -0500
@@ -30,71 +30,113 @@
 static Bool caughtShmError = False;
 static Bool needShmCleanup = False;
 
-void
-ShmCleanup()
-{
-  fprintf(stderr,"ShmCleanup called\n");
-  if (needShmCleanup) {
-    shmdt(shminfo.shmaddr);
-    shmctl(shminfo.shmid, IPC_RMID, 0);
-    needShmCleanup = False;
-  }
+static int ShmCreationXErrorHandler(Display *dpy, XErrorEvent *error) {
+	caughtShmError = True;
+	if (dpy || error) {}
+	return 0;
 }
 
-static int
-ShmCreationXErrorHandler(Display *dpy, XErrorEvent *error)
-{
-  caughtShmError = True;
-  return 0;
+void ShmDetach() {
+	if (needShmCleanup) {
+		XErrorHandler oldXErrorHandler = XSetErrorHandler(ShmCreationXErrorHandler);
+		fprintf(stderr,"ShmDetach called.\n");
+		XShmDetach(dpy, &shminfo);
+		XSync(dpy, False);
+		XSetErrorHandler(oldXErrorHandler);
+	}
 }
 
-XImage *
-CreateShmImage()
-{
-  XImage *image;
-  XErrorHandler oldXErrorHandler;
-
-  if (!XShmQueryExtension(dpy))
-    return NULL;
-
-  image = XShmCreateImage(dpy, vis, visdepth, ZPixmap, NULL, &shminfo,
-			  si.framebufferWidth, si.framebufferHeight);
-  if (!image) return NULL;
-
-  shminfo.shmid = shmget(IPC_PRIVATE,
-			 image->bytes_per_line * image->height,
-			 IPC_CREAT|0777);
+void ShmCleanup() {
+	if (needShmCleanup) {
+		fprintf(stderr,"ShmCleanup called.\n");
+		XSync(dpy, False);
+		shmdt(shminfo.shmaddr);
+		shmctl(shminfo.shmid, IPC_RMID, 0);
 
-  if (shminfo.shmid == -1) {
-    XDestroyImage(image);
-    return NULL;
-  }
-
-  shminfo.shmaddr = image->data = shmat(shminfo.shmid, 0, 0);
-
-  if (shminfo.shmaddr == (char *)-1) {
-    XDestroyImage(image);
-    shmctl(shminfo.shmid, IPC_RMID, 0);
-    return NULL;
-  }
+		needShmCleanup = False;
+	}
+}
 
-  shminfo.readOnly = True;
+Bool UsingShm() {
+	return needShmCleanup;
+}
 
-  oldXErrorHandler = XSetErrorHandler(ShmCreationXErrorHandler);
-  XShmAttach(dpy, &shminfo);
-  XSync(dpy, False);
-  XSetErrorHandler(oldXErrorHandler);
+int scale_round(int len, double fac);
+extern int scale_x, scale_y;
+extern double scale_factor_x, scale_factor_y;
 
-  if (caughtShmError) {
-    XDestroyImage(image);
-    shmdt(shminfo.shmaddr);
-    shmctl(shminfo.shmid, IPC_RMID, 0);
-    return NULL;
-  }
+XImage *
+CreateShmImage(int do_ycrop)
+{
+	XImage *image;
+	XErrorHandler oldXErrorHandler;
+	int ymax = si.framebufferHeight;
+	int xmax = si.framebufferWidth;
+
+	if (!XShmQueryExtension(dpy)) {
+		return NULL;
+	}
+	if (!appData.useShm) {
+		return NULL;
+	}
+	if (do_ycrop == -1) {
+		/* kludge to test for shm prescence */
+		return (XImage *) 0x1;
+	}
+
+	if (do_ycrop) {
+		ymax = appData.yCrop;
+	}
+
+	if (scale_x > 0) {
+		xmax = scale_round(xmax, scale_factor_x);
+		ymax = scale_round(ymax, scale_factor_y);
+	}
+
+	image = XShmCreateImage(dpy, vis, visdepth, ZPixmap, NULL, &shminfo, xmax, ymax);
+	if (!image) {
+		return NULL;
+	}
+
+	shminfo.shmid = shmget(IPC_PRIVATE, image->bytes_per_line * image->height, IPC_CREAT|0777);
+
+	if (shminfo.shmid == -1) {
+		XDestroyImage(image);
+		if (0) fprintf(stderr, "CreateShmImage: destroyed 'image' (1)\n");
+		return NULL;
+	}
+
+	shminfo.shmaddr = image->data = shmat(shminfo.shmid, 0, 0);
+
+	if (shminfo.shmaddr == (char *)-1) {
+		XDestroyImage(image);
+#if 0
+		fprintf(stderr, "CreateShmImage: destroyed 'image' (2)\n");
+#endif
+		shmctl(shminfo.shmid, IPC_RMID, 0);
+		return NULL;
+	}
+
+	shminfo.readOnly = True;
+
+	oldXErrorHandler = XSetErrorHandler(ShmCreationXErrorHandler);
+	XShmAttach(dpy, &shminfo);
+	XSync(dpy, False);
+	XSetErrorHandler(oldXErrorHandler);
+
+	if (caughtShmError) {
+		XDestroyImage(image);
+#if 0
+		fprintf(stderr, "CreateShmImage: destroyed 'image' (3)\n");
+#endif
+		shmdt(shminfo.shmaddr);
+		shmctl(shminfo.shmid, IPC_RMID, 0);
+		return NULL;
+	}
 
-  needShmCleanup = True;
+	needShmCleanup = True;
 
-  fprintf(stderr,"Using shared memory PutImage\n");
+	fprintf(stderr,"Using shared memory (PutImage ycrop=%d, Size %dx%d)\n", do_ycrop, xmax, ymax);
 
-  return image;
+	return image;
 }
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/smake vnc_unixsrc/vncviewer/smake
--- vnc_unixsrc.orig/vncviewer/smake	1969-12-31 19:00:00.000000000 -0500
+++ vnc_unixsrc/vncviewer/smake	2007-02-19 12:28:05.000000000 -0500
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+PATH=`pwd`/../..:/usr/sfw/bin:/usr/ccs/bin:$PATH
+export PATH
+if [ "X$1" != "X" ]; then
+	"$@"
+else
+	make
+	strip vncviewer
+	ls -l vncviewer
+fi
